searchNodes=[{"ref":"Mix.Tasks.Temple.Gen.Html.html","title":"Mix.Tasks.Temple.Gen.Html","type":"task","doc":"Generates controller, views, and context for an HTML resource in Temple. mix temple.gen.html Accounts User users name:string age:integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/: a context module in lib/app/accounts.ex for the accounts API a schema in lib/app/accounts/user.ex, with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web, :generators, context_app: :my_app Alternatively, the --context-app option may be supplied to the generator: mix phx.gen.html Sales User users --context-app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix phx.gen.html.temple Sales User users --web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex. Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix phx.gen.html.temple Accounts User users --table cms_users binary_id Generated migration can use binary_id for schema&#39;s primary key and its references with option --binary-id. Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for phx.gen.schema for more information on attributes."},{"ref":"Mix.Tasks.Temple.Gen.Layout.html","title":"Mix.Tasks.Temple.Gen.Layout","type":"task","doc":"Generates a Phoenix layout file in Temple. mix temple.gen.layout"},{"ref":"Mix.Tasks.Temple.Gen.Layout.html#run/1","title":"Mix.Tasks.Temple.Gen.Layout.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.UpdateMdnDocs.html","title":"Mix.Tasks.UpdateMdnDocs","type":"task","doc":""},{"ref":"Mix.Tasks.UpdateMdnDocs.html#run/1","title":"Mix.Tasks.UpdateMdnDocs.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Temple.html","title":"Temple","type":"module","doc":""},{"ref":"Temple.html#defcomponent/2","title":"Temple.defcomponent/2","type":"macro","doc":"Defines a custom component. Components are the primary way to extract partials and markup helpers. Assigns Components accept a keyword list or a map of assigns and can be referenced in the body of the component by a module attribute of the same name. This works exactly the same as EEx templates. Children If a block is passed to the component, it can be referenced by a special assign called @children. Example defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end # {:safe, &quot;&lt;div id=&quot;my-flex&quot; class=&quot;flex&quot;&gt; # &lt;div&gt;Item 1&lt;/div&gt; # &lt;div&gt;Item 2&lt;/div&gt; # &lt;div&gt;Item 3&lt;/div&gt; # &lt;/div&gt;&quot;}"},{"ref":"Temple.html#partial/1","title":"Temple.partial/1","type":"macro","doc":"Emits a Phoenix partial into the markup. temple do html lang: &quot;en&quot; do head do title &quot;MyApp&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end end"},{"ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro","doc":"Creates a markup context. All tags must be called inside of a Temple.temple/1 block. Returns a safe result of the form {:safe, result} Example team = [&quot;Alice&quot;, &quot;Bob&quot;, &quot;Carol&quot;] temple do for name &lt;- team do div class: &quot;text-bold&quot; do text name end end end # {:safe, &quot;&lt;div class=&quot;text-bold&quot;&gt;Alice&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Bob&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Carol&lt;/div&gt;&quot;}"},{"ref":"Temple.html#text/1","title":"Temple.text/1","type":"macro","doc":"Emits a text node into the markup. temple do div do text &quot;Hello, world!&quot; end end # {:safe, &quot;&lt;div&gt;Hello, world!&lt;/div&gt;&quot;}"},{"ref":"Temple.Engine.html","title":"Temple.Engine","type":"module","doc":"Temple provides a templating engine for use in Phoenix web applications. You can configure your application to use Temple templates by adding the following configuration. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # your_app_web.ex def view do quote do # ... use Temple # Replaces the call to import Phoenix.HTML end end Usage Temple templates use the .exs extension, because they are written with pure Elixir! assigns (@conn, etc) are handled the same as normal Phoenix.HTML.Engine templates. Note: The Temple.temple/1 macro is not needed for Temple templates due to the engine taking care of that for you. # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end"},{"ref":"Temple.Engine.html#compile/2","title":"Temple.Engine.compile/2","type":"function","doc":"Callback implementation for Phoenix.Template.Engine.compile/2."},{"ref":"Temple.Form.html","title":"Temple.Form","type":"module","doc":"This modules wraps all of the functions from the Phoenix.HTML.Form module to make them compatible with with Temple."},{"ref":"Temple.Form.html#checkbox/3","title":"Temple.Form.checkbox/3","type":"macro","doc":"Please see Phoenix.HTML.Form.checkbox/3 for details."},{"ref":"Temple.Form.html#color_input/3","title":"Temple.Form.color_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.color_input/3 for details."},{"ref":"Temple.Form.html#date_input/3","title":"Temple.Form.date_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.date_input/3 for details."},{"ref":"Temple.Form.html#date_select/3","title":"Temple.Form.date_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.date_select/3 for details."},{"ref":"Temple.Form.html#datetime_local_input/3","title":"Temple.Form.datetime_local_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.datetime_local_input/3 for details."},{"ref":"Temple.Form.html#datetime_select/3","title":"Temple.Form.datetime_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.datetime_select/3 for details."},{"ref":"Temple.Form.html#email_input/3","title":"Temple.Form.email_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.email_input/3 for details."},{"ref":"Temple.Form.html#file_input/3","title":"Temple.Form.file_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.file_input/3 for details."},{"ref":"Temple.Form.html#form_for/2","title":"Temple.Form.form_for/2","type":"macro","doc":"Generates an empty form tag. See Temple.Form.form_for/4 for more details"},{"ref":"Temple.Form.html#form_for/4","title":"Temple.Form.form_for/4","type":"macro","doc":"Generates a form tag with a form builder and a block. The form builder will be available inside the block through the form variable. This is a wrapper around the Phoenix.HTML.Form.form_for/4 function and accepts all of the same options. Example temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;name&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}"},{"ref":"Temple.Form.html#hidden_input/3","title":"Temple.Form.hidden_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.hidden_input/3 for details."},{"ref":"Temple.Form.html#inputs_for/4","title":"Temple.Form.inputs_for/4","type":"macro","doc":"Generate a new form builder for the given parameter in form. The form builder will be available inside the block through the inner_form variable. This is a wrapper around the Phoenix.HTML.Form.inputs_for/4 function and accepts all of the same options. Example temple do form_for @parent, Routes.some_path(@conn, :create) do text_input form, :name inputs_for form, :job do text_input inner_form, :description end inputs_for form, :children do text_input inner_form, :name end end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[name]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[job][description]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[children][1][name]&quot; type=&quot;text&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[children][2][name]&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}"},{"ref":"Temple.Form.html#multiple_select/4","title":"Temple.Form.multiple_select/4","type":"macro","doc":"Please see Phoenix.HTML.Form.multiple_select/4 for details."},{"ref":"Temple.Form.html#number_input/3","title":"Temple.Form.number_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.number_input/3 for details."},{"ref":"Temple.Form.html#password_input/3","title":"Temple.Form.password_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.password_input/3 for details."},{"ref":"Temple.Form.html#phx_label/2","title":"Temple.Form.phx_label/2","type":"macro","doc":"Please see Phoenix.HTML.Form.label/2 for details."},{"ref":"Temple.Form.html#phx_label/3","title":"Temple.Form.phx_label/3","type":"macro","doc":"Please see Phoenix.HTML.Form.label/3 for details."},{"ref":"Temple.Form.html#phx_label/4","title":"Temple.Form.phx_label/4","type":"macro","doc":"Please see Phoenix.HTML.Form.label/4 for details."},{"ref":"Temple.Form.html#range_input/3","title":"Temple.Form.range_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.range_input/3 for details."},{"ref":"Temple.Form.html#reset/2","title":"Temple.Form.reset/2","type":"macro","doc":"Please see Phoenix.HTML.Form.reset/2 for details."},{"ref":"Temple.Form.html#search_input/3","title":"Temple.Form.search_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.search_input/3 for details."},{"ref":"Temple.Form.html#select/4","title":"Temple.Form.select/4","type":"macro","doc":"Please see Phoenix.HTML.Form.select/4 for details."},{"ref":"Temple.Form.html#submit/1","title":"Temple.Form.submit/1","type":"macro","doc":"Please see Phoenix.HTML.Form.submit/1 for details."},{"ref":"Temple.Form.html#submit/2","title":"Temple.Form.submit/2","type":"macro","doc":"Please see Phoenix.HTML.Form.submit/1 for details."},{"ref":"Temple.Form.html#telephone_input/3","title":"Temple.Form.telephone_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.telephone_input/3 for details."},{"ref":"Temple.Form.html#text_area/3","title":"Temple.Form.text_area/3","type":"macro","doc":"Please see Phoenix.HTML.Form.textarea/3 for details. Note: Temple defines this function as text_area with an underscore, whereas Phoenix.HTML defines it as textarea without an underscore."},{"ref":"Temple.Form.html#text_input/3","title":"Temple.Form.text_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.text_input/3 for details."},{"ref":"Temple.Form.html#time_input/3","title":"Temple.Form.time_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.time_input/3 for details."},{"ref":"Temple.Form.html#time_select/3","title":"Temple.Form.time_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.time_select/3 for details."},{"ref":"Temple.Form.html#url_input/3","title":"Temple.Form.url_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.url_input/3 for details."},{"ref":"Temple.Link.html","title":"Temple.Link","type":"module","doc":"This modules wraps all of the functions from the Phoenix.HTML.Link module to make them compatible with with Temple."},{"ref":"Temple.Link.html#phx_button/2","title":"Temple.Link.phx_button/2","type":"macro","doc":"Please see Phoenix.HTML.Link.button/2 for details."},{"ref":"Temple.Link.html#phx_link/2","title":"Temple.Link.phx_link/2","type":"macro","doc":"Please see Phoenix.HTML.Link.link/2 for details."},{"ref":"Temple.Tags.html","title":"Temple.Tags","type":"module","doc":"The Temple.Tags module defines macros for all HTML5 compliant elements. Temple.Tags macros must be called inside of a Temple.temple/1 block. Attributes Tags accept a keyword list or a map of attributes to be emitted into the element&#39;s opening tag. Multi-word attribute keys written in snake_case (data_url) will be transformed into kebab-case (data-url). Children Non-void elements (such as div) accept a block that can be used to nest other tags or text nodes. These blocks can contain arbitrary Elixir code such as variables and for comprehensions. If you are only emitting a text node within a block, you can use the shortened syntax by passing the text in as the first parameter of the tag. Example temple do # empty non-void element div() # non-void element with keyword list attributes div class: &quot;text-red&quot;, id: &quot;my-el&quot; # # non-void element with map attributes div %{:class =&gt; &quot;text-red&quot;, &quot;id&quot; =&gt; &quot;my-el&quot;} # non-void element with children div do text &quot;Hello, world!&quot; for name &lt;- @names do div data_name: name end end # non-void element with a single text node div &quot;Hello, world!&quot;, class: &quot;text-green&quot; # void elements input name: &quot;comments&quot;, placeholder: &quot;Enter a comment...&quot; end # {:safe, # &quot;&lt;div&gt;&lt;/div&gt; # &lt;div class=&quot;text-red&quot; id=&quot;my-el&quot;&gt;&lt;/div&gt; # &lt;div&gt; # Hello, world! # &lt;div data-name=&quot;Alice&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Bob&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Carol&quot;&gt;&lt;/div&gt; # &lt;/div&gt; # &lt;div class=&quot;text-green&quot;&gt;Hello, world!&lt;/div&gt; # &lt;input name=&quot;comments&quot; placeholder=&quot;Enter a comment...&quot;&gt;&quot; # }"},{"ref":"Temple.Tags.html#a/0","title":"Temple.Tags.a/0","type":"macro","doc":"The HTML &lt;a&gt; element (or anchor element), along with its href attribute, creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL."},{"ref":"Temple.Tags.html#a/1","title":"Temple.Tags.a/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#a/2","title":"Temple.Tags.a/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#abbr/0","title":"Temple.Tags.abbr/0","type":"macro","doc":"The HTML Abbreviation element (&lt;abbr&gt;) represents an abbreviation or acronym; the optional title attribute can provide an expansion or description for the abbreviation."},{"ref":"Temple.Tags.html#abbr/1","title":"Temple.Tags.abbr/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#abbr/2","title":"Temple.Tags.abbr/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#address/0","title":"Temple.Tags.address/0","type":"macro","doc":"The HTML &lt;address&gt; element indicates that the enclosed HTML provides contact information for a person or people, or for an organization."},{"ref":"Temple.Tags.html#address/1","title":"Temple.Tags.address/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#address/2","title":"Temple.Tags.address/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#area/1","title":"Temple.Tags.area/1","type":"macro","doc":"The HTML &lt;area&gt; element defines a hot-spot region on an image, and optionally associates it with a hypertext link. This element is used only within a &lt;map&gt; element."},{"ref":"Temple.Tags.html#article/0","title":"Temple.Tags.article/0","type":"macro","doc":"The HTML &lt;article&gt; element represents a self-contained composition in a document, page, application, or site, which is intended to be independently distributable or reusable"},{"ref":"Temple.Tags.html#article/1","title":"Temple.Tags.article/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#article/2","title":"Temple.Tags.article/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#aside/0","title":"Temple.Tags.aside/0","type":"macro","doc":"The HTML &lt;aside&gt; element represents a portion of a document whose content is only indirectly related to the document&#39;s main content."},{"ref":"Temple.Tags.html#aside/1","title":"Temple.Tags.aside/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#aside/2","title":"Temple.Tags.aside/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#audio/0","title":"Temple.Tags.audio/0","type":"macro","doc":"The HTML &lt;audio&gt; element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the &lt;source&gt; element: the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream."},{"ref":"Temple.Tags.html#audio/1","title":"Temple.Tags.audio/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#audio/2","title":"Temple.Tags.audio/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#b/0","title":"Temple.Tags.b/0","type":"macro","doc":"The HTML Bring Attention To element (&lt;b&gt;)  is used to draw the reader&#39;s attention to the element&#39;s contents, which are not otherwise granted special importance."},{"ref":"Temple.Tags.html#b/1","title":"Temple.Tags.b/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#b/2","title":"Temple.Tags.b/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#base/1","title":"Temple.Tags.base/1","type":"macro","doc":"The HTML &lt;base&gt; element specifies the base URL to use for all relative URLs contained within a document. There can be only one &lt;base&gt; element in a document."},{"ref":"Temple.Tags.html#bdi/0","title":"Temple.Tags.bdi/0","type":"macro","doc":"The HTML Bidirectional Isolate element (&lt;bdi&gt;)  tells the browser&#39;s bidirectional algorithm to treat the text it contains in isolation from its surrounding text."},{"ref":"Temple.Tags.html#bdi/1","title":"Temple.Tags.bdi/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#bdi/2","title":"Temple.Tags.bdi/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#bdo/0","title":"Temple.Tags.bdo/0","type":"macro","doc":"The HTML Bidirectional Text Override element (&lt;bdo&gt;) overrides the current directionality of text, so that the text within is rendered in a different direction."},{"ref":"Temple.Tags.html#bdo/1","title":"Temple.Tags.bdo/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#bdo/2","title":"Temple.Tags.bdo/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#blockquote/0","title":"Temple.Tags.blockquote/0","type":"macro","doc":"The HTML &lt;blockquote&gt; Element (or HTML Block Quotation Element) indicates that the enclosed text is an extended quotation. Usually, this is rendered visually by indentation (see Notes for how to change it). A URL for the source of the quotation may be given using the cite attribute, while a text representation of the source can be given using the &lt;cite&gt; element."},{"ref":"Temple.Tags.html#blockquote/1","title":"Temple.Tags.blockquote/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#blockquote/2","title":"Temple.Tags.blockquote/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#body/0","title":"Temple.Tags.body/0","type":"macro","doc":"The HTML &lt;body&gt; Element represents the content of an HTML document. There can be only one &lt;body&gt; element in a document."},{"ref":"Temple.Tags.html#body/1","title":"Temple.Tags.body/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#body/2","title":"Temple.Tags.body/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#br/1","title":"Temple.Tags.br/1","type":"macro","doc":"The HTML &lt;br&gt; element produces a line break in text (carriage-return). It is useful for writing a poem or an address, where the division of lines is significant."},{"ref":"Temple.Tags.html#button/0","title":"Temple.Tags.button/0","type":"macro","doc":"The HTML &lt;button&gt; element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality."},{"ref":"Temple.Tags.html#button/1","title":"Temple.Tags.button/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#button/2","title":"Temple.Tags.button/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#canvas/0","title":"Temple.Tags.canvas/0","type":"macro","doc":"Use the HTML &lt;canvas&gt; element with either the canvas scripting API or the WebGL API to draw graphics and animations."},{"ref":"Temple.Tags.html#canvas/1","title":"Temple.Tags.canvas/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#canvas/2","title":"Temple.Tags.canvas/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#caption/0","title":"Temple.Tags.caption/0","type":"macro","doc":"The HTML Table Caption element (&lt;caption&gt;) specifies the caption (or title) of a table, and if used is always the first child of a &lt;table&gt;."},{"ref":"Temple.Tags.html#caption/1","title":"Temple.Tags.caption/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#caption/2","title":"Temple.Tags.caption/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#cite/0","title":"Temple.Tags.cite/0","type":"macro","doc":"The HTML Citation element (&lt;cite&gt;) is used to describe a reference to a cited creative work, and must include the title of that work."},{"ref":"Temple.Tags.html#cite/1","title":"Temple.Tags.cite/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#cite/2","title":"Temple.Tags.cite/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#code/0","title":"Temple.Tags.code/0","type":"macro","doc":"The HTML &lt;code&gt; element displays its contents styled in a fashion intended to indicate that the text is a short fragment of computer code."},{"ref":"Temple.Tags.html#code/1","title":"Temple.Tags.code/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#code/2","title":"Temple.Tags.code/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#col/1","title":"Temple.Tags.col/1","type":"macro","doc":"The HTML &lt;col&gt; element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a &lt;colgroup&gt; element."},{"ref":"Temple.Tags.html#colgroup/0","title":"Temple.Tags.colgroup/0","type":"macro","doc":"The HTML &lt;colgroup&gt; element defines a group of columns within a table."},{"ref":"Temple.Tags.html#colgroup/1","title":"Temple.Tags.colgroup/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#colgroup/2","title":"Temple.Tags.colgroup/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#data/0","title":"Temple.Tags.data/0","type":"macro","doc":"The HTML &lt;data&gt; element links a given content with a machine-readable translation. If the content is time- or date-related, the &lt;time&gt; element must be used."},{"ref":"Temple.Tags.html#data/1","title":"Temple.Tags.data/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#data/2","title":"Temple.Tags.data/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#datalist/0","title":"Temple.Tags.datalist/0","type":"macro","doc":"The HTML &lt;datalist&gt; element contains a set of &lt;option&gt; elements that represent the values available for other controls."},{"ref":"Temple.Tags.html#datalist/1","title":"Temple.Tags.datalist/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#datalist/2","title":"Temple.Tags.datalist/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#dd/0","title":"Temple.Tags.dd/0","type":"macro","doc":"The HTML &lt;dd&gt; element provides the details about or the definition of the preceding term (&lt;dt&gt;) in a description list (&lt;dl&gt;)."},{"ref":"Temple.Tags.html#dd/1","title":"Temple.Tags.dd/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#dd/2","title":"Temple.Tags.dd/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#del/0","title":"Temple.Tags.del/0","type":"macro","doc":"The HTML &lt;del&gt; element represents a range of text that has been deleted from a document."},{"ref":"Temple.Tags.html#del/1","title":"Temple.Tags.del/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#del/2","title":"Temple.Tags.del/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#details/0","title":"Temple.Tags.details/0","type":"macro","doc":"The HTML Details Element (&lt;details&gt;) creates a disclosure widget in which information is visible only when the widget is toggled into an &quot;open&quot; state."},{"ref":"Temple.Tags.html#details/1","title":"Temple.Tags.details/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#details/2","title":"Temple.Tags.details/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#dfn/0","title":"Temple.Tags.dfn/0","type":"macro","doc":"The HTML Definition element (&lt;dfn&gt;) is used to indicate the term being defined within the context of a definition phrase or sentence."},{"ref":"Temple.Tags.html#dfn/1","title":"Temple.Tags.dfn/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#dfn/2","title":"Temple.Tags.dfn/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#div/0","title":"Temple.Tags.div/0","type":"macro","doc":"The HTML Content Division element (&lt;div&gt;) is the generic container for flow content. It has no effect on the content or layout until styled using CSS."},{"ref":"Temple.Tags.html#div/1","title":"Temple.Tags.div/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#div/2","title":"Temple.Tags.div/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#dl/0","title":"Temple.Tags.dl/0","type":"macro","doc":"The HTML &lt;dl&gt; element represents a description list. The element encloses a list of groups of terms (specified using the &lt;dt&gt; element) and descriptions (provided by &lt;dd&gt; elements). Common uses for this element are to implement a glossary or to display metadata (a list of key-value pairs)."},{"ref":"Temple.Tags.html#dl/1","title":"Temple.Tags.dl/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#dl/2","title":"Temple.Tags.dl/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#dt/0","title":"Temple.Tags.dt/0","type":"macro","doc":"The HTML &lt;dt&gt; element specifies a term in a description or definition list, and as such must be used inside a &lt;dl&gt; element."},{"ref":"Temple.Tags.html#dt/1","title":"Temple.Tags.dt/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#dt/2","title":"Temple.Tags.dt/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#em/0","title":"Temple.Tags.em/0","type":"macro","doc":"The HTML &lt;em&gt; element marks text that has stress emphasis. The &lt;em&gt; element can be nested, with each level of nesting indicating a greater degree of emphasis."},{"ref":"Temple.Tags.html#em/1","title":"Temple.Tags.em/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#em/2","title":"Temple.Tags.em/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#embed/1","title":"Temple.Tags.embed/1","type":"macro","doc":"The HTML &lt;embed&gt; element embeds external content at the specified point in the document. This content is provided by an external application or other source of interactive content such as a browser plug-in."},{"ref":"Temple.Tags.html#fieldset/0","title":"Temple.Tags.fieldset/0","type":"macro","doc":"The HTML &lt;fieldset&gt; element is used to group several controls as well as labels (&lt;label&gt;) within a web form."},{"ref":"Temple.Tags.html#fieldset/1","title":"Temple.Tags.fieldset/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#fieldset/2","title":"Temple.Tags.fieldset/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#figcaption/0","title":"Temple.Tags.figcaption/0","type":"macro","doc":"The HTML &lt;figcaption&gt; or Figure Caption element represents a caption or legend describing the rest of the contents of its parent &lt;figure&gt; element."},{"ref":"Temple.Tags.html#figcaption/1","title":"Temple.Tags.figcaption/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#figcaption/2","title":"Temple.Tags.figcaption/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#figure/0","title":"Temple.Tags.figure/0","type":"macro","doc":"The HTML &lt;figure&gt; (Figure With Optional Caption) element represents self-contained content, potentially with an optional caption, which is specified using the (&lt;figcaption&gt;) element."},{"ref":"Temple.Tags.html#figure/1","title":"Temple.Tags.figure/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#figure/2","title":"Temple.Tags.figure/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#footer/0","title":"Temple.Tags.footer/0","type":"macro","doc":"The HTML &lt;footer&gt; element represents a footer for its nearest sectioning content or sectioning root element. A footer typically contains information about the author of the section, copyright data or links to related documents."},{"ref":"Temple.Tags.html#footer/1","title":"Temple.Tags.footer/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#footer/2","title":"Temple.Tags.footer/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#form/0","title":"Temple.Tags.form/0","type":"macro","doc":"The HTML &lt;form&gt; element represents a document section that contains interactive controls for submitting information to a web server."},{"ref":"Temple.Tags.html#form/1","title":"Temple.Tags.form/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#form/2","title":"Temple.Tags.form/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h1/0","title":"Temple.Tags.h1/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h1/1","title":"Temple.Tags.h1/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h1/2","title":"Temple.Tags.h1/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h2/0","title":"Temple.Tags.h2/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h2/1","title":"Temple.Tags.h2/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h2/2","title":"Temple.Tags.h2/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h3/0","title":"Temple.Tags.h3/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h3/1","title":"Temple.Tags.h3/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h3/2","title":"Temple.Tags.h3/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h4/0","title":"Temple.Tags.h4/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h4/1","title":"Temple.Tags.h4/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h4/2","title":"Temple.Tags.h4/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h5/0","title":"Temple.Tags.h5/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h5/1","title":"Temple.Tags.h5/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h5/2","title":"Temple.Tags.h5/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#h6/0","title":"Temple.Tags.h6/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Tags.html#h6/1","title":"Temple.Tags.h6/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#h6/2","title":"Temple.Tags.h6/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#head/0","title":"Temple.Tags.head/0","type":"macro","doc":"The HTML &lt;head&gt; element contains machine-readable information (metadata) about the document, like its title, scripts, and style sheets."},{"ref":"Temple.Tags.html#head/1","title":"Temple.Tags.head/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#head/2","title":"Temple.Tags.head/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#header/0","title":"Temple.Tags.header/0","type":"macro","doc":"The HTML &lt;header&gt; element represents introductory content, typically a group of introductory or navigational aids. It may contain some heading elements but also a logo, a search form, an author name, and other elements."},{"ref":"Temple.Tags.html#header/1","title":"Temple.Tags.header/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#header/2","title":"Temple.Tags.header/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#hr/1","title":"Temple.Tags.hr/1","type":"macro","doc":"The HTML &lt;hr&gt; element represents a thematic break between paragraph-level elements: for example, a change of scene in a story, or a shift of topic within a section."},{"ref":"Temple.Tags.html#html/0","title":"Temple.Tags.html/0","type":"macro","doc":"The HTML &lt;html&gt; element represents the root (top-level element) of an HTML document, so it is also referred to as the root element. All other elements must be descendants of this element."},{"ref":"Temple.Tags.html#html/1","title":"Temple.Tags.html/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#html/2","title":"Temple.Tags.html/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#i/0","title":"Temple.Tags.i/0","type":"macro","doc":"The HTML &lt;i&gt; element represents a range of text that is set off from the normal text for some reason. Some examples include technical terms, foreign language phrases, or fictional character thoughts. It is typically displayed in italic type."},{"ref":"Temple.Tags.html#i/1","title":"Temple.Tags.i/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#i/2","title":"Temple.Tags.i/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#iframe/0","title":"Temple.Tags.iframe/0","type":"macro","doc":"The HTML Inline Frame element (&lt;iframe&gt;) represents a nested browsing context, embedding another HTML page into the current one."},{"ref":"Temple.Tags.html#iframe/1","title":"Temple.Tags.iframe/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#iframe/2","title":"Temple.Tags.iframe/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#img/1","title":"Temple.Tags.img/1","type":"macro","doc":"The HTML &lt;img&gt; element embeds an image into the document. It is a replaced element."},{"ref":"Temple.Tags.html#input/1","title":"Temple.Tags.input/1","type":"macro","doc":"The HTML &lt;input&gt; element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent."},{"ref":"Temple.Tags.html#ins/0","title":"Temple.Tags.ins/0","type":"macro","doc":"The HTML &lt;ins&gt; element represents a range of text that has been added to a document."},{"ref":"Temple.Tags.html#ins/1","title":"Temple.Tags.ins/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#ins/2","title":"Temple.Tags.ins/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#kbd/0","title":"Temple.Tags.kbd/0","type":"macro","doc":"The HTML Keyboard Input element (&lt;kbd&gt;) represents a span of inline text denoting textual user input from a keyboard, voice input, or any other text entry device."},{"ref":"Temple.Tags.html#kbd/1","title":"Temple.Tags.kbd/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#kbd/2","title":"Temple.Tags.kbd/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#keygen/1","title":"Temple.Tags.keygen/1","type":"macro","doc":"The HTML &lt;keygen&gt; element exists to facilitate generation of key material, and submission of the public key as part of an HTML form. This mechanism is designed for use with Web-based certificate management systems. It is expected that the &lt;keygen&gt; element will be used in an HTML form along with other information needed to construct a certificate request, and that the result of the process will be a signed certificate."},{"ref":"Temple.Tags.html#label/0","title":"Temple.Tags.label/0","type":"macro","doc":"The HTML &lt;label&gt; element represents a caption for an item in a user interface."},{"ref":"Temple.Tags.html#label/1","title":"Temple.Tags.label/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#label/2","title":"Temple.Tags.label/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#legend/0","title":"Temple.Tags.legend/0","type":"macro","doc":"The HTML &lt;legend&gt; element represents a caption for the content of its parent &lt;fieldset&gt;."},{"ref":"Temple.Tags.html#legend/1","title":"Temple.Tags.legend/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#legend/2","title":"Temple.Tags.legend/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#li/0","title":"Temple.Tags.li/0","type":"macro","doc":"The HTML &lt;li&gt; element is used to represent an item in a list."},{"ref":"Temple.Tags.html#li/1","title":"Temple.Tags.li/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#li/2","title":"Temple.Tags.li/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#link/1","title":"Temple.Tags.link/1","type":"macro","doc":"The HTML External Resource Link element (&lt;link&gt;) specifies relationships between the current document and an external resource. This element is most commonly used to link to stylesheets, but is also used to establish site icons (both &quot;favicon&quot; style icons and icons for the home screen and apps on mobile devices) among other things."},{"ref":"Temple.Tags.html#main/0","title":"Temple.Tags.main/0","type":"macro","doc":"The HTML &lt;main&gt; element represents the dominant content of the &lt;body&gt; of a document. The main content area consists of content that is directly related to or expands upon the central topic of a document, or the central functionality of an application."},{"ref":"Temple.Tags.html#main/1","title":"Temple.Tags.main/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#main/2","title":"Temple.Tags.main/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#map/0","title":"Temple.Tags.map/0","type":"macro","doc":"The HTML &lt;map&gt; element is used with &lt;area&gt; elements to define an image map (a clickable link area)."},{"ref":"Temple.Tags.html#map/1","title":"Temple.Tags.map/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#map/2","title":"Temple.Tags.map/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#mark/0","title":"Temple.Tags.mark/0","type":"macro","doc":"The HTML Mark Text element (&lt;mark&gt;) represents text which is marked or highlighted for reference or notation purposes, due to the marked passage&#39;s relevance or importance in the enclosing context."},{"ref":"Temple.Tags.html#mark/1","title":"Temple.Tags.mark/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#mark/2","title":"Temple.Tags.mark/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#menu/0","title":"Temple.Tags.menu/0","type":"macro","doc":"The HTML &lt;menu&gt; element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked."},{"ref":"Temple.Tags.html#menu/1","title":"Temple.Tags.menu/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#menu/2","title":"Temple.Tags.menu/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#menuitem/0","title":"Temple.Tags.menuitem/0","type":"macro","doc":"The HTML &lt;menuitem&gt; element represents a command that a user is able to invoke through a popup menu. This includes context menus, as well as menus that might be attached to a menu button."},{"ref":"Temple.Tags.html#menuitem/1","title":"Temple.Tags.menuitem/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#menuitem/2","title":"Temple.Tags.menuitem/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#meta/1","title":"Temple.Tags.meta/1","type":"macro","doc":"The HTML &lt;meta&gt; element represents metadata that cannot be represented by other HTML meta-related elements, like &lt;base&gt;, &lt;link&gt;, &lt;script&gt;, &lt;style&gt; or &lt;title&gt;."},{"ref":"Temple.Tags.html#meter/0","title":"Temple.Tags.meter/0","type":"macro","doc":"The HTML &lt;meter&gt; element represents either a scalar value within a known range or a fractional value."},{"ref":"Temple.Tags.html#meter/1","title":"Temple.Tags.meter/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#meter/2","title":"Temple.Tags.meter/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#nav/0","title":"Temple.Tags.nav/0","type":"macro","doc":"The HTML &lt;nav&gt; element represents a section of a page whose purpose is to provide navigation links, either within the current document or to other documents. Common examples of navigation sections are menus, tables of contents, and indexes."},{"ref":"Temple.Tags.html#nav/1","title":"Temple.Tags.nav/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#nav/2","title":"Temple.Tags.nav/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#noscript/0","title":"Temple.Tags.noscript/0","type":"macro","doc":"The HTML &lt;noscript&gt; element defines a section of HTML to be inserted if a script type on the page is unsupported or if scripting is currently turned off in the browser."},{"ref":"Temple.Tags.html#noscript/1","title":"Temple.Tags.noscript/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#noscript/2","title":"Temple.Tags.noscript/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#object/0","title":"Temple.Tags.object/0","type":"macro","doc":"The HTML &lt;object&gt; element represents an external resource, which can be treated as an image, a nested browsing context, or a resource to be handled by a plugin."},{"ref":"Temple.Tags.html#object/1","title":"Temple.Tags.object/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#object/2","title":"Temple.Tags.object/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#ol/0","title":"Temple.Tags.ol/0","type":"macro","doc":"The HTML &lt;ol&gt; element represents an ordered list of items, typically rendered as a numbered list."},{"ref":"Temple.Tags.html#ol/1","title":"Temple.Tags.ol/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#ol/2","title":"Temple.Tags.ol/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#optgroup/0","title":"Temple.Tags.optgroup/0","type":"macro","doc":"The HTML &lt;optgroup&gt; element creates a grouping of options within a &lt;select&gt; element."},{"ref":"Temple.Tags.html#optgroup/1","title":"Temple.Tags.optgroup/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#optgroup/2","title":"Temple.Tags.optgroup/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#option/0","title":"Temple.Tags.option/0","type":"macro","doc":"The HTML &lt;option&gt; element is used to define an item contained in a &lt;select&gt;, an &lt;optgroup&gt;, or a &lt;datalist&gt; element. As such, &lt;option&gt; can represent menu items in popups and other lists of items in an HTML document."},{"ref":"Temple.Tags.html#option/1","title":"Temple.Tags.option/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#option/2","title":"Temple.Tags.option/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#output/0","title":"Temple.Tags.output/0","type":"macro","doc":"The HTML Output element (&lt;output&gt;) is a container element into which a site or app can inject the results of a calculation or the outcome of a user action."},{"ref":"Temple.Tags.html#output/1","title":"Temple.Tags.output/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#output/2","title":"Temple.Tags.output/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#p/0","title":"Temple.Tags.p/0","type":"macro","doc":"The HTML &lt;p&gt; element represents a paragraph."},{"ref":"Temple.Tags.html#p/1","title":"Temple.Tags.p/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#p/2","title":"Temple.Tags.p/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#param/1","title":"Temple.Tags.param/1","type":"macro","doc":"The HTML &lt;param&gt; element defines parameters for an &lt;object&gt; element."},{"ref":"Temple.Tags.html#pre/0","title":"Temple.Tags.pre/0","type":"macro","doc":"The HTML &lt;pre&gt; element represents preformatted text which is to be presented exactly as written in the HTML file."},{"ref":"Temple.Tags.html#pre/1","title":"Temple.Tags.pre/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#pre/2","title":"Temple.Tags.pre/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#progress/0","title":"Temple.Tags.progress/0","type":"macro","doc":"The HTML &lt;progress&gt; element displays an indicator showing the completion progress of a task, typically displayed as a progress bar."},{"ref":"Temple.Tags.html#progress/1","title":"Temple.Tags.progress/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#progress/2","title":"Temple.Tags.progress/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#q/0","title":"Temple.Tags.q/0","type":"macro","doc":"The HTML &lt;q&gt; element indicates that the enclosed text is a short inline quotation. Most modern browsers implement this by surrounding the text in quotation marks."},{"ref":"Temple.Tags.html#q/1","title":"Temple.Tags.q/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#q/2","title":"Temple.Tags.q/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#rp/0","title":"Temple.Tags.rp/0","type":"macro","doc":"The HTML Ruby Fallback Parenthesis (&lt;rp&gt;) element is used to provide fall-back parentheses for browsers that do not support display of ruby annotations using the &lt;ruby&gt; element."},{"ref":"Temple.Tags.html#rp/1","title":"Temple.Tags.rp/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#rp/2","title":"Temple.Tags.rp/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#rt/0","title":"Temple.Tags.rt/0","type":"macro","doc":"The HTML Ruby Text (&lt;rt&gt;) element specifies the ruby text component of a ruby annotation, which is used to provide pronunciation, translation, or transliteration information for East Asian typography. The &lt;rt&gt; element must always be contained within a &lt;ruby&gt; element."},{"ref":"Temple.Tags.html#rt/1","title":"Temple.Tags.rt/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#rt/2","title":"Temple.Tags.rt/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#ruby/0","title":"Temple.Tags.ruby/0","type":"macro","doc":"The HTML &lt;ruby&gt; element represents a ruby annotation. Ruby annotations are for showing pronunciation of East Asian characters."},{"ref":"Temple.Tags.html#ruby/1","title":"Temple.Tags.ruby/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#ruby/2","title":"Temple.Tags.ruby/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#s/0","title":"Temple.Tags.s/0","type":"macro","doc":"The HTML &lt;s&gt; element renders text with a strikethrough, or a line through it. Use the &lt;s&gt; element to represent things that are no longer relevant or no longer accurate. However, &lt;s&gt; is not appropriate when indicating document edits; for that, use the &lt;del&gt; and &lt;ins&gt; elements, as appropriate."},{"ref":"Temple.Tags.html#s/1","title":"Temple.Tags.s/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#s/2","title":"Temple.Tags.s/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#samp/0","title":"Temple.Tags.samp/0","type":"macro","doc":"The HTML Sample Element (&lt;samp&gt;) is used to enclose inline text which represents sample (or quoted) output from a computer program."},{"ref":"Temple.Tags.html#samp/1","title":"Temple.Tags.samp/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#samp/2","title":"Temple.Tags.samp/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#script/0","title":"Temple.Tags.script/0","type":"macro","doc":"The HTML &lt;script&gt; element is used to embed or reference executable code; this is typically used to embed or refer to JavaScript code."},{"ref":"Temple.Tags.html#script/1","title":"Temple.Tags.script/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#script/2","title":"Temple.Tags.script/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#section/0","title":"Temple.Tags.section/0","type":"macro","doc":"The HTML &lt;section&gt; element represents a standalone section — which doesn&#39;t have a more specific semantic element to represent it — contained within an HTML document."},{"ref":"Temple.Tags.html#section/1","title":"Temple.Tags.section/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#section/2","title":"Temple.Tags.section/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#select/0","title":"Temple.Tags.select/0","type":"macro","doc":"The HTML &lt;select&gt; element represents a control that provides a menu of options"},{"ref":"Temple.Tags.html#select/1","title":"Temple.Tags.select/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#select/2","title":"Temple.Tags.select/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#small/0","title":"Temple.Tags.small/0","type":"macro","doc":"The HTML &lt;small&gt; element represents side-comments and small print, like copyright and legal text, independent of its styled presentation. By default, it renders text within it one font-size small, such as from small to x-small."},{"ref":"Temple.Tags.html#small/1","title":"Temple.Tags.small/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#small/2","title":"Temple.Tags.small/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#source/1","title":"Temple.Tags.source/1","type":"macro","doc":"The HTML &lt;source&gt; element specifies multiple media resources for the &lt;picture&gt;, the &lt;audio&gt; element, or the &lt;video&gt; element."},{"ref":"Temple.Tags.html#span/0","title":"Temple.Tags.span/0","type":"macro","doc":"The HTML &lt;span&gt; element is a generic inline container for phrasing content, which does not inherently represent anything. It can be used to group elements for styling purposes (using the class or id attributes), or because they share attribute values, such as lang."},{"ref":"Temple.Tags.html#span/1","title":"Temple.Tags.span/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#span/2","title":"Temple.Tags.span/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#strong/0","title":"Temple.Tags.strong/0","type":"macro","doc":"The HTML Strong Importance Element (&lt;strong&gt;) indicates that its contents have strong importance, seriousness, or urgency. Browsers typically render the contents in bold type."},{"ref":"Temple.Tags.html#strong/1","title":"Temple.Tags.strong/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#strong/2","title":"Temple.Tags.strong/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#style/0","title":"Temple.Tags.style/0","type":"macro","doc":"The HTML &lt;style&gt; element contains style information for a document, or part of a document."},{"ref":"Temple.Tags.html#style/1","title":"Temple.Tags.style/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#style/2","title":"Temple.Tags.style/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#sub/0","title":"Temple.Tags.sub/0","type":"macro","doc":"The HTML Subscript element (&lt;sub&gt;) specifies inline text which should be displayed as subscript for solely typographical reasons."},{"ref":"Temple.Tags.html#sub/1","title":"Temple.Tags.sub/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#sub/2","title":"Temple.Tags.sub/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#summary/0","title":"Temple.Tags.summary/0","type":"macro","doc":"The HTML Disclosure Summary element (&lt;summary&gt;) element specifies a summary, caption, or legend for a &lt;details&gt; element&#39;s disclosure box."},{"ref":"Temple.Tags.html#summary/1","title":"Temple.Tags.summary/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#summary/2","title":"Temple.Tags.summary/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#sup/0","title":"Temple.Tags.sup/0","type":"macro","doc":"The HTML Superscript element (&lt;sup&gt;) specifies inline text which is to be displayed as superscript for solely typographical reasons."},{"ref":"Temple.Tags.html#sup/1","title":"Temple.Tags.sup/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#sup/2","title":"Temple.Tags.sup/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#table/0","title":"Temple.Tags.table/0","type":"macro","doc":"The HTML &lt;table&gt; element represents tabular data — that is, information presented in a two-dimensional table comprised of rows and columns of cells containing data."},{"ref":"Temple.Tags.html#table/1","title":"Temple.Tags.table/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#table/2","title":"Temple.Tags.table/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#tbody/0","title":"Temple.Tags.tbody/0","type":"macro","doc":"The HTML Table Body element (&lt;tbody&gt;) encapsulates a set of table rows (&lt;tr&gt; elements), indicating that they comprise the body of the table (&lt;table&gt;)."},{"ref":"Temple.Tags.html#tbody/1","title":"Temple.Tags.tbody/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#tbody/2","title":"Temple.Tags.tbody/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#td/0","title":"Temple.Tags.td/0","type":"macro","doc":"The HTML &lt;td&gt; element defines a cell of a table that contains data. It participates in the table model."},{"ref":"Temple.Tags.html#td/1","title":"Temple.Tags.td/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#td/2","title":"Temple.Tags.td/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#template/0","title":"Temple.Tags.template/0","type":"macro","doc":"The HTML Content Template (&lt;template&gt;) element is a mechanism for holding HTML that is not to be rendered immediately when a page is loaded but may be instantiated subsequently during runtime using JavaScript."},{"ref":"Temple.Tags.html#template/1","title":"Temple.Tags.template/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#template/2","title":"Temple.Tags.template/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#textarea/0","title":"Temple.Tags.textarea/0","type":"macro","doc":"The HTML &lt;textarea&gt; element represents a multi-line plain-text editing control, useful when you want to allow users to enter a sizeable amount of free-form text, for example a comment on a review or feedback form."},{"ref":"Temple.Tags.html#textarea/1","title":"Temple.Tags.textarea/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#textarea/2","title":"Temple.Tags.textarea/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#tfoot/0","title":"Temple.Tags.tfoot/0","type":"macro","doc":"The HTML &lt;tfoot&gt; element defines a set of rows summarizing the columns of the table."},{"ref":"Temple.Tags.html#tfoot/1","title":"Temple.Tags.tfoot/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#tfoot/2","title":"Temple.Tags.tfoot/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#th/0","title":"Temple.Tags.th/0","type":"macro","doc":"The HTML &lt;th&gt; element defines a cell as header of a group of table cells. The exact nature of this group is defined by the scope and headers attributes."},{"ref":"Temple.Tags.html#th/1","title":"Temple.Tags.th/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#th/2","title":"Temple.Tags.th/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#thead/0","title":"Temple.Tags.thead/0","type":"macro","doc":"The HTML &lt;thead&gt; element defines a set of rows defining the head of the columns of the table."},{"ref":"Temple.Tags.html#thead/1","title":"Temple.Tags.thead/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#thead/2","title":"Temple.Tags.thead/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#time/0","title":"Temple.Tags.time/0","type":"macro","doc":"The HTML &lt;time&gt; element represents a specific period in time."},{"ref":"Temple.Tags.html#time/1","title":"Temple.Tags.time/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#time/2","title":"Temple.Tags.time/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#title/0","title":"Temple.Tags.title/0","type":"macro","doc":"The HTML Title element (&lt;title&gt;) defines the document&#39;s title that is shown in a browser&#39;s title bar or a page&#39;s tab."},{"ref":"Temple.Tags.html#title/1","title":"Temple.Tags.title/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#title/2","title":"Temple.Tags.title/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#tr/0","title":"Temple.Tags.tr/0","type":"macro","doc":"The HTML &lt;tr&gt; element defines a row of cells in a table. The row&#39;s cells can then be established using a mix of &lt;td&gt; (data cell) and &lt;th&gt; (header cell) elements."},{"ref":"Temple.Tags.html#tr/1","title":"Temple.Tags.tr/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#tr/2","title":"Temple.Tags.tr/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#track/1","title":"Temple.Tags.track/1","type":"macro","doc":"The HTML &lt;track&gt; element is used as a child of the media elements &lt;audio&gt; and &lt;video&gt;. It lets you specify timed text tracks (or time-based data), for example to automatically handle subtitles. The tracks are formatted in WebVTT format (.vtt files) — Web Video Text Tracks or Timed Text Markup Language (TTML)."},{"ref":"Temple.Tags.html#u/0","title":"Temple.Tags.u/0","type":"macro","doc":"The HTML Unarticulated Annotation Element (&lt;u&gt;) represents a span of inline text which should be rendered in a way that indicates that it has a non-textual annotation."},{"ref":"Temple.Tags.html#u/1","title":"Temple.Tags.u/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#u/2","title":"Temple.Tags.u/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#ul/0","title":"Temple.Tags.ul/0","type":"macro","doc":"The HTML &lt;ul&gt; element represents an unordered list of items, typically rendered as a bulleted list."},{"ref":"Temple.Tags.html#ul/1","title":"Temple.Tags.ul/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#ul/2","title":"Temple.Tags.ul/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#var/0","title":"Temple.Tags.var/0","type":"macro","doc":"The HTML Variable element (&lt;var&gt;) represents the name of a variable in a mathematical expression or a programming context."},{"ref":"Temple.Tags.html#var/1","title":"Temple.Tags.var/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#var/2","title":"Temple.Tags.var/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#video/0","title":"Temple.Tags.video/0","type":"macro","doc":"The HTML Video element (&lt;video&gt;) embeds a media player which supports video playback into the document."},{"ref":"Temple.Tags.html#video/1","title":"Temple.Tags.video/1","type":"macro","doc":""},{"ref":"Temple.Tags.html#video/2","title":"Temple.Tags.video/2","type":"macro","doc":""},{"ref":"Temple.Tags.html#wbr/1","title":"Temple.Tags.wbr/1","type":"macro","doc":"The HTML &lt;wbr&gt; element represents a word break opportunity—a position within text where the browser may optionally break a line, though its line-breaking rules would not otherwise create a break at that location."},{"ref":"readme.html","title":"","type":"extras","doc":"Temple is a DSL for writing HTML using Elixir. You&#39;re probably here because you want to use Temple to write Phoenix templates, which is why Temple includes a Phoenix template engine and Temple-compatible Phoenix form helpers."},{"ref":"readme.html#installation","title":" - Installation","type":"extras","doc":"Add temple to your list of dependencies in mix.exs: def deps do [{:temple, &quot;~&gt; 0.1.0&quot;}] end"},{"ref":"readme.html#usage","title":" - Usage","type":"extras","doc":"Using Temple is a as simple as using the DSL inside of an temple/1 block. This returns a safe result of the form {:safe, html_string}. See the documentation for more details. use Temple temple do h2 &quot;todos&quot; ul class: &quot;list&quot; do for item &lt;- @items do li class: &quot;item&quot; do div class: &quot;checkbox&quot; do div class: &quot;bullet hidden&quot; end div item end end end script &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple provides an API for creating custom components that act as custom HTML elements. These components can be given props that are available inside the component definition as module attributes. The contents of a components do block are available as a special @children attribute. See the documentation for more details. defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end Phoenix.HTML Temple provides macros for working with the helpers provided by the Phoenix.HTML package. Most of the macros are purely wrappers, while the semantics of some are changed to work with Temple. See the documentation for more details. temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end Phoenix templates Add the templating engine to your Phoenix configuration. See the documentation for more details. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # your_app_web.ex def view do quote do # ... use Temple # Replaces the call to import Phoenix.HTML end end # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end Formatter To include Temple&#39;s formatter configuration, add :temple to your .formatter.exs. [ import_deps: [:temple], inputs: [&quot;*.{ex,exs}&quot;, &quot;priv/*/seeds.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;], ]"}]